#include<stdio.h>
#include<stdlib.h>
#include<conio.h>
#include<string.h>
#include<time.h>
#include<math.h>
#include "..\lib\9188A8D.h"

/*
 Use 9188 COM2 link to 9052/53 (8/16 D/I) x 2.
 address 01 : 9053-1, connect to COM2(RS485) of 9188
	      9600,N,8,1
 address 02 : 9053-2, connect to COM2(RS485) of 9188
	      9600,N,8,1
 9188 COM4 link to PC COM port

 5digitled  : digit 1 will show channel no.
	      digit 2-5 will show the DIO value
*/

unsigned CheckTime;

char h_to_a[16] ={
 '0','1','2','3','4','5','6','7',
 '8','9','A','B','C','D','E','F'
};

char *Binary[16]=
{
  "0000",
  "0001",
  "0010",
  "0011",
  "0100",
  "0101",
  "0110",
  "0111",
  "1000",
  "1001",
  "1010",
  "1011",
  "1100",
  "1101",
  "1110",
  "1111",
};

int ascii_to_hex(char c){
 if(c<='9')
	return(c-'0');
 else
	return(c-'A'+10);
}
/*-----------------------------------------------------*/
/* This function sends commands and receive result from 9000 module */
/* It also shows the DIO status on 5-digit LED */
/* It also shows the result to the PC console */
int read_9000(unsigned char *cmd)
{  unsigned char str[20];
   int val,data;
   static unsigned long count=0;

   count++;
   SendCmdTo9000(2,cmd, 0);
   printf("\nSend==> %s, Receive<== ",cmd);
   val=ReceiveResponseFrom9000(2,str, 20000L, 0);
   ClearCom2();
   if (val==NoError) {
      str[19] = '\0';
      printf("%s ",str);
      /* show the I/O value */
      data=ascii_to_hex(str[3]);
      Show5DigitLed(2,data);

      data=ascii_to_hex(str[4]);
      Show5DigitLed(3,data);

      data=ascii_to_hex(str[5]);
      Show5DigitLed(4,data);

      data=ascii_to_hex(str[6]);
      Show5DigitLed(5,data);
   }
   else printf("Errorno=%d(%s)",val,val==TimeOut?"TimeOut":"");
   return val;
}

/* ------------------------------------------------------------------- */
//char OutCmd[10]="@01";
void  main()
{ int i,k;
  long j;
  unsigned char c,cmd[80];
  int ledmode=1;
  int quit=0;
  clock_t start,end,start2;
  unsigned char str1[35],str2[35];
  unsigned char cmd1[4]="#01";
  unsigned char cmd2[12]="#020+00.000";
  unsigned char ch0[8]="+00.000\0",ch1[8]="+00.000\0",ch2[8]="+00.000\0";

  int val1,val2,data1;
  float	sum =0.000,avg=0.000;
  char *nstr;
  int ndigits=4,decpt,sign;

  InstallCom(2,9600L,8,0,1);	/* COM2, RS-485, half-duplex mode, INT	     */
				/*	 --> need to control 485 direction   */
				/*	 --> initial 485 direction = Receive */

  /* COM4, RS-232, connect to PC's COM port for download   */
  Init5DigitLed();	/* initial & blank the 5-digit LED  */
  LedOn();			/* red-LED on */
  start=clock();

  Show5DigitLed(1,1);
  read_9000("$01M");        /* read module name of address 1 */
			      /* 9017 will echo !019017 */
  DelayTimeMs(1000);

  Show5DigitLed(1,2);
  read_9000("$02M");        /* read module name of address 2 */
				  /* 9024 will echo !029024 */				  
  printf("\n*********************************"
	 "\n'V': to Get Voltage from EX9017"
	 "\n'C': to Get Current from EX9017"
	 "\n'q': quit"
	 "\nPlease keyin to select...");
AGAIN:
     if (kbhit()) {		/* is user press PC's keyboard from COM4   3A***/

	   c=getch();		/* if this key is Q or Q --> exit this program */
	   if ((c=='q') || (c=='Q')) goto BYEBYE;
	   else if ((c=='v') || (c=='V'))
            {
               SendCmdTo9000(2,"%0101080600", 0);
               SendCmdTo9000(2,"%0202330600", 0);       
            }
       else if ((c=='c') || (c=='C'))
           {
               SendCmdTo9000(2,"%01010D0600", 0);
               SendCmdTo9000(2,"%0101300600", 0);      
           }
       else goto AGAIN;
    }      
    else goto AGAIN;    
     	 
  printf("\n*********************************"
	 "\n'1': Get sum from ch0~2 of EX9017"
	 "\n'2': Get avg & A/O through EX9024"
	 "\n'q': quit"
	 "\nPlease press any key to start...");

  for (;!quit;)
  { end=clock();
	//blink the led
	if((end-start)/CLK_TCK >= 0.5)
	{  ledmode=!ledmode;  if (ledmode) LedOn(); else LedOff();
	   start=clock();
	}

	if (kbhit()) {		/* is user press PC's keyboard from COM4   3A*********/

	   c=getch();		/* if this key is Q or Q --> exit this program */
	   if ((c=='q') || (c=='Q')) quit=1;
	   else
	   {    ClearCom2();
            if(c=='1')
			{	printf("\nSend==> %s, Receive<== ",cmd1);
				SendCmdTo9000(2, cmd1, 0);
				val1=ReceiveResponseFrom9000(2, str1, 2000L, 0);
				//ClearCom2();
                if (val1==NoError)
				{	
					for (i=0;i<7;i++)
					{	ch0[i]=str1[i+1];
						ch1[i]=str1[i+8];
						ch2[i]=str1[i+15];
					}
					ch0[7]='\0';
					ch1[7]='\0';
					ch2[7]='\0';
					printf("\nCH0 = [%7s] \nCH1 = [%7s] \nCH2 = [%7s]",ch0,ch1,ch2);
					sum = atof(ch0)+atof(ch1)+atof(ch2);				
                    //if (sum < -30.000) sum = -30.000;
					//if (sum >  30.000) sum =  30.000;
					printf("\nSUM = [%6.3f]",sum);
					nstr = ecvt(sum, ndigits, &decpt, &sign);
					/* show the I/O value */
     
					if (sum >= 0.000)
					{
                       Show5DigitLed(1,16);					
					   if (sum < 10.000)
                       {    
						   nstr[4] = '\0';
						   //nstr[4] = nstr[3]; 	
						   nstr[3] = nstr[2]; 	
						   nstr[2] = nstr[1]; 	
						   nstr[1] = nstr[0];
						   nstr[0] = '0';
					   }
                    }
                    else
                    {
                       Show5DigitLed(1,17);					
					   if (sum > -10)
                       {    
						   nstr[4] = '\0';
						   //nstr[4] = nstr[3]; 	
						   nstr[3] = nstr[2]; 	
						   nstr[2] = nstr[1]; 	
						   nstr[1] = nstr[0];
						   nstr[0] = '0';
					   }
                    }
					data1=ascii_to_hex(nstr[0]);
					Show5DigitLed(2,data1);

					data1=ascii_to_hex(nstr[1]);
					Show5DigitLedWithDot(3,data1);

					data1=ascii_to_hex(nstr[2]);
					Show5DigitLed(4,data1);

					data1=ascii_to_hex(nstr[3]);
					Show5DigitLed(5,data1);

					//data1=ascii_to_hex(nstr[4]);
					//Show5DigitLed(5,data1);
				    //ReceiveResponseFrom9000(2, str1, 6000L, 0);	
				}//EOF 6A
				else printf("Errorno=%d(%s)",val1,val1==TimeOut?"TimeOut":"");
			}//if (c=='1')

			else if(c=='2')
				 {	avg = sum/3;
					printf("\nAVG = [%6.3f]",avg);
					nstr = ecvt(avg, ndigits, &decpt, &sign);

					if ((avg<10.000)&&(avg>-10.000))
					{	cmd2[5]='0';
						cmd2[6]=nstr[0];
						cmd2[7]='.';
						cmd2[8]=nstr[1];
						cmd2[9]=nstr[2];
						cmd2[10]=nstr[3];
					}
					else
					{	cmd2[5]=nstr[0];
						cmd2[6]=nstr[1];
						cmd2[7]='.';
						cmd2[8]=nstr[2];
						cmd2[9]=nstr[3];
						cmd2[10]=nstr[4];
					}
					if (avg < 0) cmd2[4] = '-';
					cmd2[11]='\0';
					
					printf("\nSend==> %11s, Receive<== ",cmd2);
					SendCmdTo9000(2, cmd2, 0);
					val2=ReceiveResponseFrom9000(2, str2, 2000L, 0);
					//ClearCom2();
                    if (val2==NoError)
					{	str2[4]= '\0';
						printf("%s ",str2);
						/* show the I/O value */
						data1=ascii_to_hex(cmd2[5]);
						Show5DigitLed(2,data1);

						data1=ascii_to_hex(cmd2[6]);
						Show5DigitLedWithDot(3,data1);

						data1=ascii_to_hex(cmd2[8]);
						Show5DigitLed(4,data1);

						data1=ascii_to_hex(cmd2[9]);
						Show5DigitLed(5,data1);

						//data1=ascii_to_hex(cmd2[10]);
						//Show5DigitLed(5,data1);
						//ReceiveResponseFrom9000(2, str2, 6000L, 0);
					}
					else printf("Errorno=%d(%s)",val2,val2==TimeOut?"TimeOut":"");
				 }//if (c=='2')
			
				printf("\n*********************************"
					"\n'1': Get sum from ch0~2 of EX9017"
					"\n'2': Get avg & A/O through EX9024"
					"\n'q': quit"
					"\nPlease press any key to start...");
		   }
	   }//EOF if (kbhit())
  }//EOF for
BYEBYE:
  RestoreCom(2);
  LedOn();
  Show5DigitLed(1,9);
  Show5DigitLed(2,1);
  Show5DigitLed(3,8);
  Show5DigitLed(4,8);
  Show5DigitLed(5,14);
  return;
}//EOF main
/* ------------------------------------------------------------------- */


