#include<stdio.h>
#include<stdlib.h>
#include<conio.h>
#include<string.h>
#include<time.h>
#include "..\lib\9188A8D.h"

/*
 Use 9188 COM2 link to 9053/52/41D(16/8 DI) x 4.
 address 01 : 9053-1, connect to COM2(RS485) of 9188
	      9600,N,8,1
 address 02 : 9053-2, connect to COM2(RS485) of 9188
	      9600,N,8,1
 address 03 : 9041-1, connect to COM2(RS485) of 9188
	      9600,N,8,1
 address 04 : 9041-2, connect to COM2(RS485) of 9188
	      9600,N,8,1
 9188 COM4 link to PC COM port
 5digitled  : digit 1 will show channel no.
	      digit 2-5 will show the input value
*/

unsigned CheckTime;

char h_to_a[16] ={
 '0','1','2','3','4','5','6','7',
 '8','9','A','B','C','D','E','F'
};

char *Binary[16]=
{
  "0000",
  "0001",
  "0010",
  "0011",
  "0100",
  "0101",
  "0110",
  "0111",
  "1000",
  "1001",
  "1010",
  "1011",
  "1100",
  "1101",
  "1110",
  "1111",
};

void S5DL(int lr_flag,int dd1,int dd2,int dd3,int dd4,int dd5)
{
  unsigned int i,j;
  unsigned int ddx[7];
  ddx[1] = dd1;
  ddx[2] = dd2;
  ddx[3] = dd3;
  ddx[4] = dd4;
  ddx[5] = dd5;
  //Init5DigitLed();		/* 5-digit LED initial */
  for (i=1 ; i<6 ; i++)
  {
       for (j=1 ; j<i+1 ; j++)
       {
        if (lr_flag == 0)
	       Show5DigitLed(6-j,ddx[i-j+1]);  /* show - in 5-digit LED */
	    else
	       Show5DigitLed(j,ddx[j]);  /* show - in 5-digit LED */	    
        DelayMs(20);
       }
  }
  /*Show5DigitLed(1,dd1);		   show - in 5-digit LED */
  /*Show5DigitLed(2,dd2);		   show - in 5-digit LED */
  /*Show5DigitLed(3,dd3);		   show - in 5-digit LED */
  /*Show5DigitLed(4,dd4);		   show - in 5-digit LED */
  /*Show5DigitLed(5,dd5);		   show - in 5-digit LED */  
}
/*-----------------------------------------------------*/
/* This function sends commands and receive result from 9000 module */
/* It also shows the DIO status on 5-digit LED */
/* It also shows the result to the PC console */
int read_9000(unsigned char *cmd)
{  unsigned char str[20];
   int i,val,data;
   static unsigned long count=0;

   count++;
   SendCmdTo9000(2,cmd, 0);
   printf("\n[%lu]Send=%s, Receive=",count,cmd);
   val=ReceiveResponseFrom9000(2,str, 60000L, 0);
   if (val==NoError) {
      printf("%s ",str);
      /* show the I/O value */
      data=ascii_to_hex(str[1]);
      Show5DigitLed(2,data);
      printf("[%s",Binary[data]);
      data=ascii_to_hex(str[2]);
      Show5DigitLed(3,data);
      printf(" %s",Binary[data]);
      data=ascii_to_hex(str[3]);
      Show5DigitLed(4,data);
      printf(" %s",Binary[data]);
      data=ascii_to_hex(str[4]);
      Show5DigitLed(5,data);
      printf(" %s]",Binary[data]);
   }
   else 
   {
     printf("Errorno=%d(%s)",val,val==TimeOut?"TimeOut":"");
	 for(i=2;i<6;i++) Show5DigitLed(i,18);
   }
   return val;
}

/*---------------------------------------------------*/
/* Get the module name */
int GetModuleName(int addr,char *name)
{ char cmd[10];
  int val,i;
  cmd[0]='$';
  cmd[1]=h_to_a[(addr>>4)&0xf];
  cmd[2]=h_to_a[addr&0xf];
  cmd[3]='M';
  cmd[4]=0;
  SendCmdTo9000(2,cmd, 0);
  val=ReceiveResponseFrom9000(2,cmd, 60000L, 0);
  if(val==NoError) {
     if(cmd[0]=='!'){
        for(i=0;i<4;i++){
	        name[i]=cmd[3+i];
        }
        name[i]=0;
	    return NoError;
     }
     else return PortError;
  }
  return val;
}

/* ------------------------------------------------------------------- */
char OutCmd[10]="@01";
int Name[4];
void  main()
{ int i,k;
  unsigned char c,cmd[80];
  int ledmode=1;
  int quit=0;
  int channel=-1;
  clock_t start,end,start2;

  InstallCom(2,9600L,8,0,1);	/* COM2, RS-485, half-duplex mode, INT	     */
				/*	 --> need to control 485 direction   */
				/*	 --> initial 485 direction = Receive */

  /* COM4, RS-232, connect to PC's COM port for download   */
  Init5DigitLed();	/* initial & blank the 5-digit LED  */
  LedOn();			/* red-LED on			    */
  start=clock();
  //get the module name in the network
  for(i=1;i<=4;i++){
     if(GetModuleName(i,cmd)==NoError){
	    Name[i]=atoi(cmd);
	    Show5DigitLed(1,i);
	    Show5DigitLed(2,cmd[0]-'0');
	    Show5DigitLed(3,cmd[1]-'0');
	    Show5DigitLed(4,cmd[2]-'0');
	    Show5DigitLed(5,cmd[3]-'0');
     }
     else {
	    Name[i]=0;
	    Show5DigitLed(1,i);
	    Show5DigitLed(2,17);
	    Show5DigitLed(3,17);
	    Show5DigitLed(4,17);
	    Show5DigitLed(5,17);
     }
     DelayMs(1000);
  }

  for(i=1;i<=4;i++){
      if(Name[i]==9052 || Name[i]==9053 || Name[i]==9041 ){
    	 channel=i;
	     Show5DigitLed(1,i);
	     OutCmd[2]=i+'0';
	     break;
      }
  }

  printf("\n'1': show channel 1\n'2': show channel 2"
	 "\n'3': show channel 3\n'4': show channel 4"
	 "\n'q'  : quit"
	 "\npress any key to start.");

  if(Name[channel]==9052 || Name[channel]==9053 || Name[channel]==9041 ||
     Name[channel]==7052 || Name[channel]==7053 || Name[channel]==7041){
     while(!quit) {
       end=clock();
       //blink LED
       if((end-start)/CLK_TCK >= 0.5){
	      ledmode=!ledmode;  
          if (ledmode) LedOn(); else LedOff();
	      start=clock();
       }
       if (kbhit4()) {		/* is user press PC's keyboard from COM4   */
	       c=getch4();		/* if this key is Q or Q --> exit this program */
	       switch(c){
	             case 'q': case 'Q': quit=1; break;
	             case '1':
	             case '2':
	             case '3':
	             case '4':
		         //if(Name[c-'0']==9052 || Name[c-'0']==9053 || Name[c-'0']==9041 ||
		         //   Name[c-'0']==7052 || Name[c-'0']==7053 || Name[c-'0']==7041){
		            channel=c-'0';
		            Show5DigitLed(1,channel);
		            OutCmd[2]=c;
                 //}
	             read_9000(OutCmd);
		         break;
           }//end of switch(c)
       }//end of if(kbhit4())
       //else {
	   //     read_9000(OutCmd);
       //}
     }
  }
  else printf("\nCannot find 9053 or 9041 on address 0-3");
  S5DL(0,9,1,8,8,14);
  RestoreCom(2);
} //end of main
/* ------------------------------------------------------------------- */
